package Quest;

use strict;
use quest_const;

# _I^Cv
my $random_probab_suffix = RANDOM_PROBAB_SUFFIX; # m̃TtBbNX
my $random_probab_wildcard = RANDOM_PROBAB_WILDCARD; # m̃ChJ[h
my $random_thresh_suffix = RANDOM_THRESH_SUFFIX; # 臒l̃TtBbNX
my $random_range_key_min = RANDOM_RANGE_KEY_MIN; # ͈͂̍ŏl\L[
my $random_range_key_max = RANDOM_RANGE_KEY_MAX; # ͈͂̍ől\L[

# f[^̋؂
my $separator_eol = SEPARATOR_EOL; # sp
my $separator_elem = SEPARATOR_ELEM; # vfԗp
my $separator_pair = SEPARATOR_PAIR; # L[ƒlyAp
my $separator_list = SEPARATOR_LIST; # Xgp
my $separator_value_hash = SEPARATOR_VALUE_HASH; # f[^l̃nbVp

# NGXg`̃L[
my $quest_key_kind = QUEST_KEY_KIND; # 
my $quest_key_state = QUEST_KEY_STATE; # 
my $quest_key_expire = QUEST_KEY_EXPIRE; # 
my $quest_key_progress = QUEST_KEY_PROGRESS; # o

# HTMLtH[̃L[
my $form_key_command = FORM_KEY_COMMAND; # R}h

# [U[p[^̃L[
my $user_param_key_kind = USER_PARAM_KEY_KIND; # 

# vOC̃pbP[W
my $plugin_package_prefix = PLUGIN_PACKAGE_PREFIX; # vtBbNX

my @loaded_plugin_list = (); # [hĂvOC̃nbV
my %indiv_quest_hash = (); # [U[IDL[Ƃ鏊LNGXgXg̃nbV
my %user_param_hash = (); # [U[IDL[Ƃ郆[U[NGXgp[^̃nbV
my %update_flag_hash = (); # [U[IDL[Ƃ鏊LNGXgt@C̍XVKvǂ̃nbV
my %quest_name_hash = (); # ʂL[ƂNGXg̃nbV

# NGXg̊eR}hɉtH[Ăяo
#     yz
#         'Ȃ
#     y߂lz
#         Ȃ
sub call_form{
	if($main::Fm{$form_key_command} eq FORM_VALUE_COMMAND_LIST){
		# Xg\R}h̏ꍇ
		&call_command();
	}
	elsif($main::Fm{$form_key_command} eq FORM_VALUE_COMMAND_TRADE){
		# R}h̏ꍇ
		&main::contact_form();
	}
	else{
		# ̑̃R}h̏ꍇ
		&main::play_form();
	}
}

# NGXg̊eR}hĂяo
#     yz
#         'Ȃ
#     y߂lz
#         Ȃ
sub call_command{
	require &PRIVATE_LIB_FILE();
	&command($main::Fm{$form_key_command});
}

# NGXg̍ss
#     yz
#         '[U[ID'
#         [U[NGXgp[^̃XJ[t@X
#         's'
#         [p[^1,EEE,p[^n]
#     y߂lz
#         sꍇ͐^AȊO͋U
sub action{
	my $id = shift;
	my $qstprmRef = shift;
	my $actionKind = shift;
	my $paramListRef = shift;

	my $errFormat = 'NGXgANV̌ĂяoɎs܂Bi%sj';
	&error(sprintf($errFormat, 'ID`')) if($id eq '');
	&error(sprintf($errFormat, 'NGXgp[^`')) unless(defined($qstprmRef));
	&error(sprintf($errFormat, 'ANVʂ`')) if($actionKind eq '');
	$user_param_hash{$id} = &deserialize_user_param($$qstprmRef) unless(exists($user_param_hash{$id}));
	my $userParamHashRef = $user_param_hash{$id};
	return if($userParamHashRef->{$user_param_key_kind} ne $actionKind);

	my $questHashRef = &get_undertaken(&read_indiv_quest_data($id));
	unless($questHashRef){
		if($userParamHashRef->{$user_param_key_kind} ne ''){
			$userParamHashRef->{$user_param_key_kind} = '';
			$$qstprmRef = &serialize_user_param($userParamHashRef);
		}
		return;
	}
	my $kind = &get_kind($questHashRef);
	if($userParamHashRef->{$user_param_key_kind} ne $kind){
		$userParamHashRef->{$user_param_key_kind} = $kind;
		$$qstprmRef = &serialize_user_param($userParamHashRef);
	}
	# NGXgʂƍsʂقȂꍇ͍sȂ
	return if($kind ne $actionKind);
	# ؂̏ꍇ͍sȂ
	my $expire = int(&get_expire($questHashRef));
	return if($expire > 0 && time > $expire);
	# B𖞂Ăꍇ͍sȂ
	return if(&call_plugin($kind, PLUGIN_SUB_JUDGE, [$questHashRef]));
	# s
	my $result = &call_plugin($kind, PLUGIN_SUB_ACTION, [$questHashRef, $paramListRef]);
	$update_flag_hash{$id} = 1 if($result && !exists($update_flag_hash{$id}));
	return $result;
}

# NGXgXV
#     yz
#         Ȃ
#     y߂lz
#         Ȃ
sub update{
	return unless(%update_flag_hash);
	foreach my $id (keys(%update_flag_hash)){
		&write_indiv_quest_data($id, $indiv_quest_hash{$id}) if(exists($indiv_quest_hash{$id}));
		delete($update_flag_hash{$id});
	}
}

# 󂯂ĂNGXg̊ȈՏ擾
#     yz
#         '[U[ID'
#         [U[NGXgp[^̃XJ[t@X
#     y߂lz
#         󂯂ĂNGXgꍇ͂̃NGXg̊ȈՏ񕶎AȊOundef
sub undertaken_info{
	my $id = shift;
	my $qstprmRef = shift;

	my $errFormat = 'NGXg̎擾Ɏs܂Bi%sj';
	&error(sprintf($errFormat, 'ID`')) if($id eq '');
	&error(sprintf($errFormat, 'NGXgp[^`')) unless(defined($qstprmRef));
	my $userParamHashRef = &deserialize_user_param($$qstprmRef);
	return if($userParamHashRef->{$user_param_key_kind} eq '');
	my $questHashRef = &get_undertaken(&read_indiv_quest_data($id));
	return unless($questHashRef);
	my $kind = &get_kind($questHashRef);
	return sprintf('%sNGXg󂯂Ă܂BiLF%sAo߁F%sj', &call_plugin($kind, PLUGIN_SUB_NAME, []), &get_expire_text($questHashRef), &call_plugin($kind, PLUGIN_SUB_PROGRESS, [$questHashRef]));
}

# fobOo͂s
#     yz
#         'bZ[W' ܂ ['bZ[W1',EEE,'bZ[Wn']
#         EEE
#             
#         Tu[`t@X
#         
#         EEE
#     y߂lz
#         Ȃ
#     y̑z
#         IS_DEBUGtOȔꍇ͉sȂ
sub debug{
	return unless(IS_DEBUG);
	if(ref($_[0]) eq 'CODE'){
		my $code = shift;

		$code->(@_);
	}
	else{
		# bZ[Wɏo͂
		my $msgListRef = &get_message_list;
		&message(map {'debug&gt; ' . $_} @$msgListRef);
	}
}

# bZ[Wo͂s
#     yz
#         'bZ[W' ܂ ['bZ[W1',EEE,'bZ[Wn']
#         EEE
#     y߂lz
#         Ȃ
sub message{
	my $msgListRef = &get_message_list;
	push(@main::msg, @$msgListRef) if(@$msgListRef);
}

# o͗p̃bZ[WXg擾
#     yz
#         'bZ[W' ܂ ['bZ[W1',EEE,'bZ[Wn']
#         EEE
#     y߂lz
#         ['bZ[W1',EEE,'bZ[Wn']
sub get_message_list{
	my @msgList = ();
	foreach my $obj (@_){
		next unless(defined($obj));
		if(&is_scalar($obj)){
			push(@msgList, $obj);
		}
		elsif(&is_arrayref($obj)){
			push(@msgList, grep {defined($_)} @$obj);
		}
		else{
			push(@msgList, ref($obj));
		}
	}
	return \@msgList;
}

# G[s
#     yz
#         'bZ[W'
#     y߂lz
#         Ȃ
sub error{
	my $msg = shift;

	&main::error($msg);
}

# XJ[ǂ擾
#     yz
#         t@X
#     y߂lz
#         z񃊃t@XȂ^AȊO͋U
sub is_scalar{
	my $obj = shift;

	return ref($obj) eq '';
}

# z񃊃t@Xǂ擾
#     yz
#         t@X
#     y߂lz
#         z񃊃t@XȂ^AȊO͋U
sub is_arrayref{
	my $obj = shift;

	return ref($obj) eq 'ARRAY';
}

# nbVt@Xǂ擾
#     yz
#         t@X
#     y߂lz
#         nbVt@XȂ^AȊO͋U
sub is_hashref{
	my $obj = shift;

	return ref($obj) eq 'HASH';
}

# [U[NGXgp[^fVACY
#     yz
#         '[U[NGXgp[^'
#     y߂lz
#         {'L[1'=>'l1',EEE,'L[n'=>'ln'}
sub deserialize_user_param{
	my $param = shift;

	return {} if($param eq '');
	my $hashRef = &deserialize_hash($param, '[U[NGXgp[^');
	my $keyHashRef = REF_HASH_USER_PARAM_KEY;
	foreach my $key (keys(%$hashRef)){
		delete($hashRef->{$key}) unless(exists($keyHashRef->{$key}));
	}
	return $hashRef;
}

# [U[NGXgp[^fVACY
#     yz
#         {'L[1'=>'l1',EEE,'L[n'=>'ln'}
#     y߂lz
#         '[U[NGXgp[^'
sub serialize_user_param{
	my $hashRef = shift;

	return '' unless(&is_hashref($hashRef));
	my %hash = %$hashRef;
	my $keyHashRef = REF_HASH_USER_PARAM_KEY;
	foreach my $key (keys(%hash)){
		delete($hash{$key}) unless(exists($keyHashRef->{$key}));
	}
	return &serialize_hash(\%hash);
}

# LNGXgt@C̃pX擾
#     yz
#         '[U[ID'
#     y߂lz
#         'LNGXgt@C̃pX'
sub get_indiv_quest_file{
	my $id = shift;

	return INDIV_DIR . sprintf(INDIV_QUEST_FILE_FORMAT, $id);
}

# LNGXgt@Cǂݍ
#     yz
#         '[U[ID'
#     y߂lz
#         LNGXgf[^̔z񃊃t@X
sub read_indiv_quest_data{
	my $id = shift;

	unless(exists($indiv_quest_hash{$id})){
		my $file = &get_indiv_quest_file($id);
		my $msg = sprintf('LNGXgt@CAID=%s', $id);
		my $dataListRef = &read_data($file, $msg);
		my @questList = map {&deserialize_data($_, $msg)} @$dataListRef;
		$indiv_quest_hash{$id} = \@questList;
	}
	return $indiv_quest_hash{$id};
}

# LNGXgt@C
#     yz
#         '[U[ID'
#         LNGXgf[^̔z񃊃t@X
#     y߂lz
#         Ȃ
sub write_indiv_quest_data{
	my $id = shift;
	my $questListRef = shift;

	my $file = &get_indiv_quest_file($id);
	&write_data($file, $questListRef, sprintf('LNGXgt@CAID=%s', $id));
	$indiv_quest_hash{$id} = $questListRef;
}

# f[^fVACY
#     yz
#         'L[1=l1<>EEE<>L[n=ln'
#         'G[bZ[WɊ܂߂郁bZ[W'
#     y߂lz
#         {'L[1'=>l1,EEE,'L[n'=>ln}
#              ĺAXJ[Az񃊃t@XAnbVt@X̂ǂꂩ
sub deserialize_data{
	my $data = shift;
	my $msg = shift;

	my %decode = ();
	my ($key, $value);
	my $prefix;
	my @list = $data ne '' ? split(/\Q${separator_elem}\E/o, $data . SEPARATOR_ELEM . 'x') : ();
	foreach my $elem (@list[0 .. $#list - 1]){
		($key, $value) = split(/\Q${separator_pair}\E/o, $elem, 2);
		$key = '' unless(defined($key));
		$value = '' unless(defined($value));
		&error(sprintf('f[^̃L[܂Bi%sj', $msg)) if($key eq '');
		&error(sprintf('f[^̃L[dĂ܂Bi%sAkey=%sj', $msg, $key)) if(exists($decode{$key}));
		$prefix = substr($value, 0, 1, '');
		if($prefix eq TYPE_PREFIX_SCALAR){
			# XJ[^̏ꍇ
			# XJ[ƂĈ
			# $value͂łɃvtBbNXς
		}
		elsif($prefix eq TYPE_PREFIX_ARRAY){
			# z^̏ꍇ
			# z񃊃t@XƂĈ
			$value = &deserialize_array($value);
		}
		elsif($prefix eq TYPE_PREFIX_HASH){
			# nbV^̏ꍇ
			# nbVt@XƂĈ
			$value = &deserialize_hash($value, sprintf('%sAdataKey=%s', $msg, $key));
		}
		else{
			&error(sprintf('NGXgf[^^słBi%sAkey=%s,prefix=%sj', $msg, $key, $prefix));
		}
		$decode{$key} = $value;
	}
	return \%decode;
}

# f[^VACY
#     yz
#         {'L[1'=>l1,EEE,'L[n'=>ln}
#              ĺAXJ[Az񃊃t@XAnbVt@X̂ǂꂩ
#     y߂lz
#         'L[1=l1<>EEE<>L[n=ln'
sub serialize_data{
	my $hashRef = shift;

	my $key;
	return join(
		SEPARATOR_ELEM,
		map {
			$key = $_;
			join(
				SEPARATOR_PAIR,
				$key,
				&is_arrayref($hashRef->{$key}) ? (TYPE_PREFIX_ARRAY . &serialize_array($hashRef->{$key})) :
					&is_hashref($hashRef->{$key}) ? (TYPE_PREFIX_HASH . &serialize_hash($hashRef->{$key})) :
						(TYPE_PREFIX_SCALAR . $hashRef->{$key})
			);
		} sort keys(%$hashRef)
	);
}

# zf[^^fVACY
#     yz
#         'l1,EEE,ln'
#     y߂lz
#         ['l1',EEE,'ln']
sub deserialize_array{
	my $data = shift;

	my @list = ();
	if($data ne ''){
		@list = split(/\Q${separator_list}\E/o, $data . SEPARATOR_LIST . 'x');
		@list = @list[0 .. $#list - 1];
	}
	return \@list;
}

# zf[^^VACY
#     yz
#         ['l1',EEE,'ln']
#     y߂lz
#         'l1,EEE,ln'
sub serialize_array{
	my $listRef = shift;

	return '' unless(&is_arrayref($listRef));
	return join(SEPARATOR_LIST, @$listRef);
}

# nbVf[^^fVACY
#     yz
#         'L[1=>l1,EEE,L[n=>ln'
#         'G[bZ[WɊ܂߂郁bZ[W'
#     y߂lz
#         {'L[1'=>'l1',EEE,'L[n'=>'ln'}
sub deserialize_hash{
	my $data = shift;
	my $msg = shift;

	my %hash = ();
	my ($key, $value);
	foreach my $elem (@{&deserialize_array($data)}){
		($key, $value) = split(/\Q${separator_value_hash}\E/o, $elem, 2);
		$key = '' unless(defined($key));
		$value = '' unless(defined($value));
		&error(sprintf('nbVf[^^̃L[dĂ܂Bi%sAkey=%sj', $msg, $key)) if(exists($hash{$key}));
		$hash{$key} = $value;
	}
	return \%hash;
}

# nbVf[^^VACY
#     yz
#         {'L[1'=>'l1',EEE,'L[n'=>'ln'}
#     y߂lz
#         'L[1=>l1,EEE,L[n=>ln'
sub serialize_hash{
	my $hashRef = shift;

	return '' unless(&is_hashref($hashRef));
	return join(SEPARATOR_LIST, map {$_ . SEPARATOR_VALUE_HASH . $hashRef->{$_}} sort keys(%$hashRef));
}

# 󂯒̃CfbNX擾
#     yz
#         [NGXgf[^̃nbVt@X1,EEE,NGXgf[^̃nbVt@Xn]
#     y߂lz
#         󂯒̃NGXgꍇ͂̃CfbNXAȂꍇ-1
sub get_undertaken_index{
	my $questListRef = shift;

	foreach my $index (0 .. $#$questListRef){
		return $index if(&get_state($questListRef->[$index]) eq STATE_UNDERTAKEN);
	}
	return -1;
}

# 󂯒̃NGXg擾
#     yz
#         [NGXgf[^̃nbVt@X1,EEE,NGXgf[^̃nbVt@Xn]
#     y߂lz
#         󂯒̃NGXgꍇ͂̃nbVt@XAȂꍇundef
sub get_undertaken{
	my $questListRef = shift;

	my $index = &get_undertaken_index($questListRef);
	return if($index == -1);
	return $questListRef->[$index];
}

# t@Cǂݍ
#     yz
#         't@CpX'
#         'G[bZ[WɊ܂߂郁bZ[W'
#     y߂lz
#         ǂݍ񂾃f[^̔z񃊃t@X
sub read_data{
	my $file = shift;
	my $msg = shift;

	&update_permission($file, FILE_PERMISSION, $msg) unless(-f $file);
	open(FILE, '<', $file) or &error(sprintf('t@C̓ǂݍ݂Ɏs܂Bi%sj', $msg));
	my @data = <FILE>;
	close(FILE);
	@data = grep {$_ ne ''} map {(split(/\Q${separator_eol}\E/o, $_, 2))[0]} @data;
	return \@data;
}

# t@C
#     yz
#         't@CpX'
#         ރf[^̔z񃊃t@X
#         'G[bZ[WɊ܂߂郁bZ[W'
#     y߂lz
#         Ȃ
sub write_data{
	my $file = shift;
	my $dataListRef = shift;
	my $msg = shift;

	&update_permission($file, FILE_PERMISSION, $msg) unless(-f $file);
	open(FILE, '>', $file) or &error(sprintf('t@C݂̏Ɏs܂Bi%sj', $msg));
	foreach(@$dataListRef){
		print FILE &is_hashref($_) ? &serialize_data($_) : $_, SEPARATOR_EOL, "\n";
	}
	close(FILE);
}

# t@C̃p[~bVXV
#     yz
#         't@CpX'
#         p[~bV
#         'G[bZ[WɊ܂߂郁bZ[W'
#     y߂lz
#         Ȃ
sub update_permission{
	my $file = shift;
	my $permission = shift;
	my $msg = shift;

	unless(-f $file){
		open(FILE, '>>', $file) or &error(sprintf('p[~bVXVŃt@C̃I[vɎs܂Bi%sj', $msg));
		close(FILE);
	}
	chmod($permission, $file) == 1 or &error(sprintf('p[~bVXVɎs܂Bi%sj', $msg))
}

# NGXgʂ擾
#     yz
#         NGXgf[^̃nbVt@X
#             
#         NGXgݒf[^̃nbVt@X
#     y߂lz
#         NGXgʁif[^Ɠ̌^j
sub get_kind{
	my $questHashRef = shift;

	return $questHashRef->{$quest_key_kind};
}

# 擾
#     yz
#         NGXgf[^̃nbVt@X
#             
#         NGXgݒf[^̃nbVt@X
#     y߂lz
#         if[^Ɠ̌^j
sub get_expire{
	my $questHashRef = shift;

	return $questHashRef->{$quest_key_expire};
}

# NGXgԂ擾
#     yz
#         NGXgf[^̃nbVt@X
#             
#         NGXgݒf[^̃nbVt@X
#     y߂lz
#         NGXgԁif[^Ɠ̌^j
sub get_state{
	my $questHashRef = shift;

	return $questHashRef->{$quest_key_state};
}

# NGXgo߂擾
#     yz
#         NGXgf[^̃nbVt@X
#         vf[^^Cv
#     y߂lz
#         NGXgo߁ivf[^^CvŎw肳ꂽ^j
sub get_progress{
	my $questHashRef = shift;
	my $type = shift;

	my $progress = $questHashRef->{$quest_key_progress};
	# f[^^CvvƈقȂꍇ͗vf[^^Cv̏l߂
	if($type eq TYPE_FLAG_SCALAR){
		$progress = '' unless(&is_scalar($progress));
	}
	elsif($type eq TYPE_FLAG_ARRAY){
		$progress = [] unless(&is_arrayref($progress));
	}
	elsif($type eq TYPE_FLAG_HASH){
		$progress = {} unless(&is_hashref($progress));
	}
	return $progress;
}

# NGXgo߂ݒ肷
#     yz
#         NGXgf[^̃nbVt@X
#         NGXgo߁iXJ[܂͔z񃊃t@X܂̓nbVt@Xj
#     y߂lz
#         Ȃ
sub set_progress{
	my $questHashRef = shift;
	my $progress = shift;

	$questHashRef->{$quest_key_progress} = $progress;
}

# ̕\擾
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         '̕\'
sub get_expire_text{
	my $questHashRef = shift;

	my $expire = &get_expire($questHashRef);
	my ($second, $minute, $hour, $day, $month, $year) = gmtime($expire + GMTIME_DIFF);
	return $expire > 0 ? sprintf('%dN%d%d %d%d%db%s', $year + 1900, $month + 1, $day, $hour, $minute, $second, time > $expire ? 'i؂j' : '') : 'Ȃ';
}

# z񃊃t@XуnbVt@X̃_1vf擾
#     yz
#         [vf1,EEE,vfn] ܂ {"min"=>ŏl,"max"=>ől} ܂ {"臒l1"=>vf1,EEE,"臒ln"=>vfn}
#         'G[bZ[W'
#     y߂lz
#         z񃊃t@X̃_1vf
sub get_random_elem{
	my $obj = shift;
	my $msg = shift;

	return &get_random_elemlist($obj, 1, $msg)->[0];
}

# z񃊃t@X̃_ȕvf擾
#     yz
#         [vf1,EEE,vfn] ܂ {"min"=>ŏl,"max"=>ől} ܂ {"臒l1"=>vf1,EEE,"臒ln"=>vfn}
#         
#         'G[bZ[W'
#     y߂lz
#         [vf1,EEE,vfn]
#     y̑z
#         ߂l͍őłSvfƂȂ
sub get_random_elemlist{
	my $obj = shift;
	my $num = shift;
	my $msg = shift;

	$num = int($num);
	&error($msg . 'iw萔0j') if($num < 0);
	my @list = ();
	if(&is_arrayref($obj)){
		&error($msg . 'iw萔vf𒴂Ăj') if($num > @$obj);
		if($num > 0){
			my @allList = @$obj;
			foreach(1 .. $num){
				push(@list, splice(@allList, int(rand(@allList)), 1));
			}
		}
	}
	elsif(&is_hashref($obj)){
		&error($msg . 'ivf0j') unless(%$obj);
		my $elemNum = keys(%$obj);
		if($elemNum == 2 && exists($obj->{$random_range_key_min}) && exists($obj->{$random_range_key_max}) && $obj->{$random_range_key_min} =~ /^\-?\d+$/o && $obj->{$random_range_key_max} =~ /^\-?\d+$/o){
			my $min = int($obj->{$random_range_key_min});
			my $max = int($obj->{$random_range_key_max});
			&error($msg . 'iŏlől𒴂Ăj') if($min > $max);
			&error($msg . 'iw萔vf𒴂Ăj') if($num > $max - $min + 1);
			if($num > 0){
				if($num == 1){
					push(@list, $min + int(rand($max - $min + 1)));
				}
				else{
					my @allList = $min .. $max;
					foreach(1 .. $num){
						push(@list, splice(@allList, int(rand(@allList)), 1));
					}
				}
			}
		}
		elsif((grep {&is_thresh_str($_)} values(%$obj)) == $elemNum){
			my $thresh;
			my @dataList = ();
			while(my ($data, $thresh) = each(%$obj)){
				$thresh = int($thresh);
				push(@dataList, [$thresh, $data]) if($thresh > 0);
			}
			&error($msg . 'iw萔vf𒴂Ăj') if($num > @dataList);
			if($num > 0){
				@dataList = sort {$b->[0] <=> $a->[0]} @dataList;
				my $count;
				foreach(1 .. $num){
					$thresh = int(rand(int($dataList[0]->[0])));
					$count = @dataList;
					foreach my $index (1 .. $#dataList){
						if(int($dataList[$index]->[0]) <= $thresh){
							$count = $index;
							last;
						}
					}
					push(@list, splice(@dataList, int(rand($count)), 1)->[1]);
				}
			}
		}
		elsif((grep {&is_probab_str($_)} values(%$obj)) == $elemNum){
			# NOTEF _ȉ̌i13xjƐ̎Ɋۂ߂Ă܂
			my $decimalPlace = 0;
			my $decimalPlaceIndex = 0;
			my @dataList = ();
			my $wildcardIndex = -1;
			while(my ($data, $probab) = each(%$obj)){
				if($probab eq RANDOM_PROBAB_WILDCARD . RANDOM_PROBAB_SUFFIX){
					&error($msg . 'iChJ[hm܂܂Ăj') if($wildcardIndex != -1);
					$wildcardIndex = @dataList;
					$probab = '';
				}
				else{
					$probab += 0;
					&error($msg . 'ilmɈȂ܂܂Ăj') if($probab =~ /[^\d\.]/o);
					next if($probab <= 0);
					$decimalPlaceIndex = index($probab, '.');
					$decimalPlace = length($probab) - $decimalPlaceIndex - 1 if($decimalPlaceIndex != -1 && length($probab) - $decimalPlaceIndex - 1 > $decimalPlace);
				}
				push(@dataList, [$probab, $data]);
			}
			my $magnification = 10 ** $decimalPlace;
			my $totalRate = 0;
			foreach my $index (0 .. $#dataList){
				if($dataList[$index]->[0] eq ''){
					$wildcardIndex = $index;
				}
				else{
					$dataList[$index]->[0] = int($dataList[$index]->[0] * $magnification);
					$totalRate += $dataList[$index]->[0];
				}
			}
			my $maxRate = 100 * $magnification;
			&error($msg . 'im̍v100%𒴂Ăj') if($totalRate > $maxRate);
			if($wildcardIndex != -1){
				if($totalRate < $maxRate){
					$dataList[$wildcardIndex]->[0] = $maxRate - $totalRate;
				}
				else{
					splice(@dataList, $wildcardIndex, 1);
				}
			}
			else{
				&error($msg . 'im̍v100%j') if($totalRate < $maxRate);
			}
			&error($msg . 'iw萔vf𒴂Ăj') if($num > @dataList);
			$totalRate = 0;
			@dataList = map {
				$totalRate += $_->[0];
				[$_->[0], $_->[1], $totalRate];
			} sort {
				$a->[0] <=> $b->[0];
			} @dataList;
			my $rnd;
			my $foundIndex;
			my $targetIndex;
#			my ($minIndex, $maxIndex);
			foreach my $pos (1 .. $num){
				$rnd = int(rand($totalRate));
#				$minIndex = 0;
#				$maxIndex = $#dataList;
				$foundIndex = -1;
				foreach(0 .. $#dataList){
#					$targetIndex = $minIndex + (($maxIndex - $minIndex + 1) >> 1);
#					if(($targetIndex == 0 || $dataList[$targetIndex - 1]->[2] <= $rnd) && $rnd < $dataList[$targetIndex]->[2]){
#						# 𖞂ꍇ
#						$foundIndex = $targetIndex;
#						last;
#					}
#					elsif($rnd < $dataList[$targetIndex]->[2]){
#						# Ⴂmɔ͈͂ύX
#						$maxIndex = $targetIndex - 1;
#					}
#					else{
#						# mɔ͈͂ύX
#						$minIndex = $targetIndex + 1;
#					}
#					&error($msg . 'im͈͕̔ύXɎsj') if($minIndex > $#dataList || $maxIndex < 0 || $maxIndex < $minIndex);
					# ȈՂȌ@iLRg͓񕪒T́j
					$targetIndex = $#dataList - $_;
					if(($targetIndex == 0 || $dataList[$targetIndex - 1]->[2] <= $rnd) && $rnd < $dataList[$targetIndex]->[2]){
						$foundIndex = $targetIndex;
						last;
					}
				}
				&error($msg . 'imɂ郉_IɎsj') if($foundIndex == -1);
				push(@list, $dataList[$foundIndex]->[1]);
				if($pos != $num){
					splice(@dataList, $foundIndex, 1);
					$totalRate = $foundIndex > 0 ? $dataList[$foundIndex - 1]->[2] : 0;
					foreach my $index ($foundIndex .. $#dataList){
						$totalRate += $dataList[$index]->[0];
						$dataList[$index]->[2] = $totalRate;
					}
				}
			}
		}
		else{
			&error($msg . 'imwł͈͎włȂj');
		}
	}
	else{
		&error($msg . 'f[^^Cvs');
	}
	return \@list;
}

# 񂪊m`ǂ擾
#     yz
#         ''
#     y߂lz
#         m`Ȃ^AȊO͋U
sub is_probab_str{
	my $str = shift;

	return $str =~ /^(?:(?:\d+(?:\.\d+)?)|\Q${random_probab_wildcard}\E)\Q${random_probab_suffix}\E$/o;
}

# 臒l`ǂ擾
#     yz
#         ''
#     y߂lz
#         臒l`Ȃ^AȊO͋U
sub is_thresh_str{
	my $str = shift;

	return $str =~ /^\d+\Q${random_thresh_suffix}\E$/o;
}

# vOC̃Tu[`Ăяo
#     yz
#         'vOC'
#         'Tu[`'
#         [1,EEE,n]
#     y߂lz
#         ĂяoTu[`̖߂liXJ[j
sub call_plugin{
	my $pluginName = shift;
	my $subName = shift;
	my $argListRef = shift;

	my $isGetName = $subName eq PLUGIN_SUB_NAME;
	return $quest_name_hash{$pluginName} if($isGetName && exists($quest_name_hash{$pluginName}));
	my $file = &get_plugin_file($pluginName);
	unless(exists($INC{$file})){
		&unload_plugin() if(MAX_LOAD_PLUGIN_LIB > 0 && @loaded_plugin_list >= MAX_LOAD_PLUGIN_LIB);

		my $loadErrFormat = 'NGXgvOCi%sj̃[hɎs܂Bi%sj';
		-f $file or &error(sprintf($loadErrFormat, $pluginName, 't@C݂Ȃ'));
		do $file;
		push(@loaded_plugin_list, $pluginName) if(exists($INC{$file}));
		!$@ or &error(sprintf($loadErrFormat, $pluginName, $@));
		my $supportSubName = PLUGIN_PACKAGE_PREFIX . $pluginName . '::' . PLUGIN_SUB_SUPPORT;
		defined(&$supportSubName) or &error(sprintf($loadErrFormat, $pluginName, 'T|[gmF݂Ȃ'));
		my $supportSubRef = \&$supportSubName;
		my $isSupported = eval{$supportSubRef->(VERSION_MAJOR, VERSION_MINOR)};
		!$@ or &error(sprintf($loadErrFormat, $pluginName, sprintf('T|[gmFG[F%s', $@)));
		$isSupported or &error(sprintf($loadErrFormat, $pluginName, 'T|[g'));
	}

	my $fullSubName = PLUGIN_PACKAGE_PREFIX . $pluginName . '::' . $subName;
	my $callErrFormat = 'NGXgvOC%šĂяoɎs܂Bi%sj';
	defined(&$fullSubName) or &error(sprintf($callErrFormat, $pluginName, sprintf('`F%s', $fullSubName)));
	my $subRef = \&$fullSubName;
	my $ret = eval{$subRef->(@$argListRef)};
	!$@ or &error(sprintf($callErrFormat, $pluginName, sprintf('G[F%s', $@)));
	$quest_name_hash{$pluginName} = $ret if($isGetName);
	return $ret;
}

# vOCt@C̃pX擾
#     yz
#         'vOC'
#     y߂lz
#         'vOCt@C̃pX'
sub get_plugin_file{
	my $name = shift;

	return PLUGIN_DIR . $name . PLUGIN_LIB_FILE_EXT;
}

# [hĂvOCA[h
#     yz
#         Ȃ
#     y߂lz
#         Ȃ
#     y̑z
#         SȃA[hł͂Ȃ
sub unload_plugin{
	my $package;
	foreach my $name (@loaded_plugin_list){
		$package = PLUGIN_PACKAGE_PREFIX . $name;

		no strict 'refs';
		undef(@{$package . '::ISA'});
		undef(%{$package . '::'});
		delete(${$plugin_package_prefix}{$name . '::'});
		delete($INC{&get_plugin_file($name)});
	}
	undef(@loaded_plugin_list);
}

1;
